// use task to generate clock and reset

module clock_reset(interface i);

  parameter bit ACTIVE_RESET = 0;
  parameter HALF_CLK_PERIOD = 5;
  parameter RST_LENGTH = 20;

  task run;
      i.clk = 0;
      i.rst = ACTIVE_RESET;
      
      fork
            clk_gen(HALF_CLK_PERIOD);
            rst_gen(RST_LENGTH);
      join_none

  endtask

  task clk_gen(input int half_clk_period);
    forever begin
        #(half_clk_period);
        i.clk = ~i.clk;
        //$display ("clk tick @ %t\n", $time);
    end
  endtask
  
  task rst_gen(input int rst_length);
    #rst_length;
    i.rst = ~i.rst;
    //$display ("rst end @ %t\n", $time);
    
  endtask

endmodule:clock_reset

