interface sync_fifo_if;
   parameter WIDTH = 32;
   typedef logic [WIDTH-1 : 0] word_t;
   
   //timeunit 1ns;
   //timeprecision 100ps;
   
   bit clk,rst;
   logic rd;
   logic wr;
   wire full;
   wire empty;
   wire almost_full;
   wire almost_empty;
   word_t din;
   word_t dout;
   
   
  parameter hold_time = 1;  
  parameter setup_time = 0;

   
   //modport should be used for DUT
    modport sync_fifo_rtl_mp (
        input clk,rst,rd,wr,din,
        output dout,full,empty,almost_full,almost_empty);
  
  // wr_driver_mp used in class wr_driver
  //modport wr_driver_mp (
  //    input clk,rst,full,almost_full,
  //    output din,wr);
  
  // clocking block is used for testbench transactor (From TLM to Pin-level)
  //-----------------------
  // driver clocking block
  //-----------------------
  clocking wr_driver_cb @ (posedge clk);
   default input #setup_time output #hold_time;
        input full,almost_full;
        output din,wr;
  endclocking : wr_driver_cb 
  
  clocking rd_driver_cb @ (posedge clk);
   default input #setup_time output #hold_time;
        input empty,almost_empty,dout;
        output rd;
  endclocking : rd_driver_cb

  //------------------------
  // monitor clocking block
  //------------------------
  clocking wr_monitor_cb @ (posedge clk);
   default input #setup_time output #hold_time;
        input full,almost_full,din,wr;
  endclocking : wr_monitor_cb 
  
  clocking rd_monitor_cb @ (posedge clk);
   default input #setup_time output #hold_time;
        input empty,dout,rd;
  endclocking : rd_monitor_cb

  //-----------------------
  // scoreboard
  //-----------------------
  clocking sb_cb @ (posedge clk);
   default  input #setup_time output #hold_time;
  endclocking : sb_cb
  
endinterface:sync_fifo_if

